
#
# Program to test buttons that appear on the bottom of
# fileselection, selection and message boxes.
#
#

global ok cancel help apply 
global okCallback cancelCallback helpCallback applyCallback 
global okLabel cancelLabel helpLabel applyLabel 

set ok             ""
set cancel         ""
set help           ""
set apply          ""

set okCallback     ""
set cancelCallback ""
set helpCallback   ""
set applyCallback  ""

set okLabel        ""
set cancelLabel    ""
set helpLabel      ""
set applyLabel     ""

proc quitCB {cbs} {
    VtClose
    exit 0
}

proc oneArgCB {option parameter cbs} {
	global okCallback cancelCallback helpCallback applyCallback 
	global okLabel cancelLabel helpLabel applyLabel 

	if {[keylget cbs set]} {
		eval set $option [list "-$option $parameter"]
	} else {
		eval set $option [list ""]
	}
}

proc noArgCB {option cbs} {
	global ok cancel help apply 

	if {[keylget cbs set]} {
		eval set $option [list -$option]
	} else {
		eval set $option [list ""]
	}
}

proc dummyCB {cbs} {
}

proc destroyCB {cbs} {
	VtDestroyDialog [keylget cbs widget]
}

proc showSelCB {cbs} {
	global ok cancel help apply sb
	global okCallback cancelCallback helpCallback applyCallback 
	global okLabel cancelLabel helpLabel applyLabel 

	set but [keylget cbs widget]

	set sb [eval VtSelectionDialog $but.sb \
				       $ok $okCallback $okLabel \
				       $cancel $cancelCallback $cancelLabel \
				       $help $helpCallback $helpLabel \
				       $apply $applyCallback $applyLabel \
					    [list -itemList { {one}
							    {two}
							    {three}}]]
	VtShow $sb
}


proc showFsbCB {cbs} {
	global ok cancel help apply sb
	global okCallback cancelCallback helpCallback applyCallback 
	global okLabel cancelLabel helpLabel applyLabel 

	set but [keylget cbs widget]

	set fsb [eval VtFileSelectionDialog $but.sb \
				       $ok $okCallback $okLabel \
				       $cancel $cancelCallback $cancelLabel \
				       $help $helpCallback $helpLabel \
				       $apply $applyCallback $applyLabel]
	VtShow $fsb
}

proc showMsgCB {cbs} {
	global ok cancel help apply sb
	global okCallback cancelCallback helpCallback applyCallback 
	global okLabel cancelLabel helpLabel applyLabel 


	set but [keylget cbs widget]

	set msg [eval VtMessageDialog $but.sb \
				       $ok $okCallback $okLabel \
				       $cancel $cancelCallback $cancelLabel \
				       $help $helpCallback $helpLabel \
				       $apply $applyCallback $applyLabel \
					    [list -message "Hi There"]]
	VtShow $msg
}


#
# Start Program
#
#

set app [VtOpen buttons]

set fn [VtStartForm $app.form -title "Button test" ]

set rc1 [VtRowColumn $fn.rc1   \
		-borderWidth 2 \
		-topSide FORM \
		-leftSide FORM \
		-topOffset 20  \
		-leftOffset 40 \
                -CHARM_topOffset 1 \
                -CHARM_leftOffset 1 ]
VtToggleButton $rc1.but1 -label "ok"      -callback "noArgCB ok"
VtToggleButton $rc1.but2 -label "cancel"  -callback "noArgCB cancel"
VtToggleButton $rc1.but3 -label "apply"   -callback "noArgCB apply"
VtToggleButton $rc1.but4 -label "help"    -callback "noArgCB help"

set rc2 [VtRowColumn $fn.rc2   \
		-borderWidth 2 \
		-topSide FORM \
		-leftSide $rc1 \
		-topOffset 20  \
		-leftOffset 40 \
                -CHARM_topOffset 1 \
                -CHARM_leftOffset 1 ]
VtToggleButton $rc2.but1 -label "okCallback"  \
			 -callback "oneArgCB okCallback dummyCB"
VtToggleButton $rc2.but2 -label "cancelCallback" \
			 -callback "oneArgCB cancelCallback dummyCB"
VtToggleButton $rc2.but3 -label "applyCallback"  \
			 -callback "oneArgCB applyCallback dummyCB"
VtToggleButton $rc2.but4 -label "helpCallback"   \
			 -callback "oneArgCB helpCallback dummyCB"

set rc3 [VtRowColumn $fn.rc3   \
		-borderWidth 2 \
		-topSide FORM \
		-leftSide $rc2 \
		-topOffset 20  \
		-leftOffset 40 \
                -CHARM_topOffset 1 \
                -CHARM_leftOffset 1 ]
VtToggleButton $rc3.but1 -label "okLabel" \
			 -callback "oneArgCB okLabel OK"
VtToggleButton $rc3.but2 -label "cancelLabel" \
			 -callback "oneArgCB cancelLabel CANCEL"
VtToggleButton $rc3.but3 -label "applyLabel"  \
			 -callback "oneArgCB applyLabel APPLY"
VtToggleButton $rc3.but4 -label "helpLabel"   \
			 -callback "oneArgCB helpLabel HELP"

set rc_bottom [VtRowColumn $fn.rc_bottom  \
		-spacing 5 \
		-leftSide $rc1 \
		-topOffset 20 \
		-leftOffset 30 \
		-below $rc2 \
                -CHARM_topOffset 1 \
                -CHARM_spacing 0 \
                -CHARM_leftOffset 1 ]
VtPushButton $rc_bottom.show    -label "Show Selection Dialog" \
			        -callback showSelCB
VtPushButton $rc_bottom.showfsb -label "Show FileSelection Dialog" \
			        -callback showFsbCB
VtPushButton $rc_bottom.showMsg -label "Show Message Dialog" \
			        -callback showMsgCB
VtPushButton $rc_bottom.quit -label "Quit" -labelCenter \
			     -callback quitCB


VtShow $fn
VtMainLoop
